#include <cstdlib>
#include <iostream>
#include<stdio.h>
#include<conio.h>
#include<string.h>

using namespace std;

//funo que, dado um nmero decimal, o converte em romano
void convertDecimalRoman(int numero, char romano[15]) {
     int milhar,centena,dezena,unidade;

     milhar=numero/1000;
     strcpy(romano," ");
     switch (milhar)
     {
	 case 1:strcat(romano,"M");break;
	 case 2:strcat(romano,"MM");break;
	 case 3:strcat(romano,"MMM");break;
     }
     centena=(numero%1000)/100;
     switch (centena)
     { 
	 case 1:strcat(romano,"C");break;
	 case 2:strcat(romano,"CC");break;
	 case 3:strcat(romano,"CCC");break;
	 case 4:strcat(romano,"CD");break;
	 case 5:strcat(romano,"D");break;
	 case 6:strcat(romano,"DC");break;
	 case 7:strcat(romano,"DCC");break;
	 case 8:strcat(romano,"DCCC");break;
	 case 9:strcat(romano,"CM");break;
     } 
     dezena=((numero%1000)%100)/10;
     switch (dezena)
     { 
	 case 1:strcat(romano,"X");break;
	 case 2:strcat(romano,"XX");break;
	 case 3:strcat(romano,"XXX");break;
	 case 4:strcat(romano,"XL");break;
	 case 5:strcat(romano,"L");break;
	 case 6:strcat(romano,"LX");break;
	 case 7:strcat(romano,"LXX");break;
	 case 8:strcat(romano,"LXXX");break;
	 case 9:strcat(romano,"XC");break;
     }
     unidade=((numero%1000)%100)%10;
     switch (unidade)
     {
	 case 1:strcat(romano,"I");break;
	 case 2:strcat(romano,"II");break;
	 case 3:strcat(romano,"III");break;
	 case 4:strcat(romano,"IV");break;
	 case 5:strcat(romano,"V");break;
	 case 6:strcat(romano,"VI");break;
	 case 7:strcat(romano,"VII");break;
	 case 8:strcat(romano,"VIII");break;
	 case 9:strcat(romano,"IX");break;
     }
     
};

//funo auxiliar que retorna os valores de I, X, V, L, C, D e M
int retornaValor (char a) {
    int retorno = 0;
    if ( a == 'I' ) {
         retorno = 1;
    }
    else if ( a == 'X' ) {
         retorno = 10;
    }
    else if ( a == 'V' ) {
         retorno = 5;
    }
    else if ( a == 'L' ) {
         retorno = 50;
    }
    else if ( a == 'C' ) {
         retorno = 100;
    }
    else if ( a == 'D' ) {
         retorno = 500;
    }
    else if ( a == 'M' ) {
         retorno  = 1000;
    }
    return retorno;
}

//funo que, dado uma string com o romano, ela retorna o inteiro correspondente
int converteRomanDecimal(char roman[15]) {
    int retorno = 0;
    int a,b = 0;
    int i = 0;
    int aux = strlen (roman);
    if (aux == 1) {
       retorno = retornaValor(roman[0]);                                          
    }
    else {
         while ( i < aux ) {
               a = retornaValor(roman[i]);
               b = retornaValor(roman[i+1]);
               if ( b == 0 ) {
                    retorno = retorno + retornaValor(roman[i]);
                    i++;
               }
               else {
                    if ( a < b )  {
                       retorno = retorno + retornaValor(roman[i+1]) - retornaValor(roman[i]);
                       i = i + 2;
                    }
                    else {
                         retorno = retorno + retornaValor(roman[i]);
                         i++;
                    }
               }
         }          
    }
    return retorno;
};


//main, responsvel pela execuo e pela interface desenvolvida
int main(int argc, char *argv[])
{
    //declarao das variveis
    
    //os 2 nmeros romanos que sero dados como entrada
    char primeiro[15] = "";
    char segundo[15] = "";
    //o resultado em romano
    char resultado[15] = "";
    //a representao inteira dos romanos dados como entrada
    int first;
    int second;
    
    //resultado da operao em inteiro
    int result = 0;
    
    //variveis auxiliares
    int auxiliar = 0;
    int auxiliar2 = 0;
    char auxiliar3;
    
    printf("------ Operacoes Basicas com Numeros Romanos ------\n");
    
    do {
        
inicio:        printf("\nDigite a operacao que deseja executar\n");
        printf("1 - Adicao\n");
        printf("2 - Subtracao\n");
        printf("3 - Multiplicacao\n");
        printf("4 - Divisao\n");
        printf("Opcao: ");
        scanf("%i",&auxiliar);
        if( (auxiliar != 1) && (auxiliar !=2) && (auxiliar !=3) && (auxiliar != 4) ) {
            printf("Opcao Invalida\n");
            goto inicio;
        } 
        
        
        printf("Digite o primeiro numero romano (em maiusculo): ");
        scanf("%s",primeiro);
        if ( strstr(primeiro,"i") != NULL || strstr(primeiro,"v") != NULL || strstr(primeiro,"x") != NULL || strstr(primeiro,"l") != NULL ||
         strstr(primeiro,"c") != NULL || strstr(primeiro,"d") != NULL || strstr(primeiro,"m") != NULL  ) {
             printf("\nInvalido! Digite apenas em maiusculo\n");                 
             goto inicio;
           } 

        printf("\nDigite o segundo numero romano (em maiusculo): ");
        scanf("%s",segundo);
        if ( strstr(segundo,"i") != NULL || strstr(segundo,"v") != NULL || strstr(segundo,"x") != NULL || strstr(segundo,"l") != NULL ||
         strstr(segundo,"c") != NULL || strstr(segundo,"d") != NULL || strstr(segundo,"m") != NULL  ) {
             printf("\nInvalido! Digite apenas em maiusculo\n");                 
             goto inicio;
           }
       
        first = converteRomanDecimal(primeiro);
        second = converteRomanDecimal(segundo);
        switch(auxiliar) {
               case 1: result = first + second; break;
               case 2: result = first - second; break;
               case 3: result = first*second; break;
               case 4: result = first/second;break;
               default: result = 0; break;
        }
        
        if ( result == 0 ) {
            printf("Resultado ZERO. No existe nos romanos!\n");     
        }
        else {
                convertDecimalRoman(result,resultado);
                printf("\n O resultado e: %s\n",resultado);
        }
        
        auxiliar2 = 0;
        while ( auxiliar2 == 0 ) {
              printf("Deseja continuar: s ou n (S ou N)?: ");
              auxiliar3 = getch();
              if(auxiliar3 == 'n' || auxiliar3 == 'N') {
                           goto fim;//artifcio de programao no recomendado. Aqui utilizado com parcimnia para resolver o problema
              }
              else if (auxiliar3 == 'S' || auxiliar3 == 's') {
                   auxiliar2 = 1;
              }
              else {
                   printf("Opcao Invalida\n");
              }
        }
        printf("\n\n\n");
        
    }
    while(true);
    
    fim: printf("\n Fim \n");
    system("PAUSE");
    return EXIT_SUCCESS;
}
